
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>
#include "penta.h"

main()
{
    PENTA *pen;
    OBJECT *obj;
    TEKI *neko,*teki;
    KeySym key;
    int stage;
    int life;
    char string[10];
    

    display = XOpenDisplay (NULL);                      /* Display */
    window = XCreateSimpleWindow (display,RootWindow(display,0),
				  100,100,650,700,2,BlackPixel(display,0),
				  WhitePixel(display,0)); /* Window */
    XSelectInput (display,window,KeyPressMask | KeyReleaseMask| ExposureMask); 
    XMapWindow (display,window);                         /* Window */

    /*   */   
    stage = 1;

    create_bitmap();                                     /* Bitmapκ */




    obj = (OBJECT *) loadfile(obj,stage);
    neko = (TEKI *) load_teki(neko,stage);
    pen = (PENTA *) load_pen(pen,stage);
 
    pen->life = 3;
    pen->stage = stage;

    while(1) {
	XNextEvent (display,&event);
	switch(event.type) {
	  case Expose :
	    zanki(pen);
	    penta_draw(pen);
	    obj_draw(obj);  
	    teki_event(neko,pen,obj);  
	    break;
 	    
	  case KeyPress :
	    teki = neko;

	    pen->old_pen_x = pen->pen_x;
	    pen->old_pen_y = pen->pen_y;
	    penta_clear(pen);	    
	    XLookupString (&event,string,10,&key,NULL); 

	    penta_move(pen,XKeysymToString(key));
	    move_event(pen,obj,neko);
	    penta_draw(pen);
	    teki_event(neko,pen,obj); 

	  
	    
	    if ( key == XK_Return )
	      {
		  if ( pen->life > 0 ) {
		      XClearWindow(display,window);
		 
		      pen->life = pen->life - 1;
		      life = pen->life;
		      stage = pen->stage;
		      
		      obj = (OBJECT *) loadfile(obj,pen->stage);
		      neko = (TEKI *) load_teki(neko,pen->stage);
		      pen = (PENTA *) load_pen(pen,pen->stage);
		      penta_draw(pen);
		      obj_draw(obj);  
		      teki_event(neko,pen,obj);
		      pen->life = life;
		      pen->stage = stage;
		      zanki(pen);
		    }
		  else
		    exit(1);
	      }

	    while ( teki != NULL ) {
	      if ( check_teki_pen(pen,teki) == 1 )
		{
		 
		  pen->life = pen->life - 1;
		  life = pen->life;
		  stage = pen->stage;
		  if ( pen->life > 0 )
		    {
		      XClearWindow(display,window);
		      
		      obj = (OBJECT *) loadfile(obj,pen->stage);
		      neko = (TEKI *) load_teki(neko,pen->stage);
		      pen = (PENTA *) load_pen(pen,pen->stage);
		      penta_draw(pen);
		      obj_draw(obj);  
		      teki_event(neko,pen,obj);
		      pen->life = life;
		      pen->stage = stage;
		      zanki(pen);
		    }
		  else
		    exit (1);
		}
	      else
		teki = teki->next;
	    }

	    if (check_special(obj) == 1)
	      {

		life = pen->life;
		XClearWindow(display,window);
		pen->stage = pen->stage + 1;
		stage = pen->stage;
		if ( pen->stage == 10 ) {
		  printf("Game Over\n");
		  exit(1);}
		
		printf("stage = %d\n",pen->stage);
		obj = (OBJECT *) loadfile(obj,pen->stage);
		neko = (TEKI *) load_teki(neko,pen->stage);
		pen = (PENTA *) load_pen(pen,pen->stage);
		penta_draw(pen);
		obj_draw(obj);  
		teki_event(neko,pen,obj);
		pen->life = life;
		pen->stage = stage;
		zanki(pen);
		    }
	    break;
	  }
    }

}




