#include <stdio.h>
#include <stdlib.h>
#include "penta.h"


/* $B$Z$s$?$HJ*BN$N@\?($rD4$Y$k4X?t(B */
OBJECT *check_pen_obj(pen,obj)
PENTA *pen; /* $B$Z$s$?$N9=B$BN(B */
OBJECT *obj; /* $BJ*BN$N@~7A%j%9%H$N@hF,(B */
{
    PENTA *p;
    OBJECT *o;
    int px,py,pw,ph;
    int ox,oy,ow,oh;

    p = pen;
    o = obj;
    pw = ow = p_width;
    ph = oh = p_height;
    px = p->pen_x;
    py = p->pen_y;

 
    while ( o != NULL )
	{
	    ox = o->obj_x;
	    oy = o->obj_y;
	    
	    if ( check(px,py,pw,ph,ox,oy,ow,oh) == 1 ) 
		return(o); /* $B9=B$BN$=$N$b$N$rJV$9(B */
	    else
		o = o->next;
	}
    p->pen_x = p->old_pen_x;
    p->pen_y = p->old_pen_y;
    return(0);
}


/* $B%A%'%C%/%7%9%F%`$N%3%"(B */
int check(px,py,pw,ph,ox,oy,ow,oh)
     int px,py,pw,ph,ox,oy,ow,oh;
{
  
      if ( 
	  (( px <= ox ) && ( px + pw > ox ) ||
	   ( px < ox + ow ) && ( px + pw > ox + ow ) ||
	   ( px >= ox ) && ( px +pw < ox + ow ))
	  &&
	  (( py >= oy ) && (py < oy + oh ) || 
	   ( py + ph > oy ) && ( py + ph < oy +oh ) ||
	   ( py >= oy ) && ( py + ph < oy + oh ))
	  )
	return(1);
      else
	return(0);
    }

/* $BJ*BNF1;N$N@\?($rD4$Y$k4X?t(B */
int check_obj_obj(obj1,obj2)
     OBJECT *obj1; /* $B4p=`$H$J$k9=B$BN(B */
     OBJECT *obj2; /* $B@~7A%j%9%H$N@hF,(B */
{
  OBJECT *p;

  p = obj2;

  while( p != NULL ) {

    if ( (obj1 != obj2) && check(obj1->obj_x,obj1->obj_y,p_width,p_height,
				 obj2->obj_x,obj2->obj_y,p_width,p_height)
	== 1 )
      return (1);
    p = p->next;
  }
    return (0);
}   

/* $BJ*BN$,#38DB7$C$?$+D4$Y$k4X?t(B  */
int bingo(obj0,obj1,obj2)
OBJECT *obj0;
OBJECT *obj1;
OBJECT *obj2;
{
    int m0x,m0y,m1x,m1y,m2x,m2y,mh,mw;
    
    m0x = obj0->obj_x;
    m0y = obj0->obj_y;
    m1x = obj1->obj_x;
    m1y = obj1->obj_y;
    m2x = obj2->obj_x;
    m2y = obj2->obj_y;
    mh = mw = p_width;

    if  (( m0y == m1y && m1y == m2y ) && 
         (( m0x + mw == m1x && m1x + mw == m2x ) ||
	  ( m0x + mw == m2x && m2x + mw == m1x ) ||
	  ( m0x - mw == m1x && m0x + mw == m2x ) ||
	  ( m0x - mw == m2x && m0x + mw == m1x ) ||
	  ( m1x + mw == m0x && m0x + mw == m2x ) ||
	  ( m1x + mw == m2x && m2x + mw == m0x ) ||
	  ( m1x - mw == m0x && m1x + mw == m2x ) ||
          ( m1x - mw == m2x && m1x + mw == m0x ) ||
	  ( m2x + mw == m0x && m0x + mw == m1x ) ||
	  ( m2x + mw == m1x && m1x + mw == m0x ) ||
	  ( m2x - mw == m0x && m2x + mw == m1x ) ||
	  ( m2x - mw == m1x && m2x + mw == m0x ))||
       	(( m0x == m1x && m1x == m2x ) &&
	 (( m0y + mh == m1y && m1y + mh == m2y ) ||
	  ( m0y + mh == m2y && m2y + mh == m1y ) ||
	  ( m0y - mh == m1y && m0y + mh == m2y ) ||
	  ( m0y - mh == m2y && m0y + mh == m1y ) ||
	  ( m1y + mh == m0y && m0y + mh == m2y ) ||
	  ( m1y + mh == m2y && m2y + mh == m0y ) ||
	  ( m1y - mh == m0y && m1y + mh == m2y ) ||
	  ( m1y - mh == m2y && m1y + mh == m0y ) ||
	  ( m2y + mh == m0y && m0y + mh == m1y ) ||
	  ( m2y + mh == m1y && m1y + mh == m0y ) ||
	  ( m2y - mh == m0y && m2y + mh == m1y ) ||
	  ( m2y - mh == m1y && m2y + mh == m0y ))))
	return(1);
    else
	return(0);

}

/* $B%9%F!<%8%/%j%"$N>r7o$rK~$?$7$?$+D4$Y$k4X?t(B */
int check_special(obj)
OBJECT *obj;
{
    OBJECT *p;
    OBJECT *tmp[3];
    int i;

    p = obj;
    i = 0;
    while ( p != NULL ) {
	if ( p->zokusei == 4 ) { 
	    tmp[i] = p;
	    i++;
	}
	p = p->next;
    }
    if ( bingo(tmp[0],tmp[1],tmp[2]) == 1 )
      {
	/* printf("bingo\n"); */
	return(1);
      }
    else
      return(0);
}

	    

/* $BE(F1;N$N=E$J$j$rD4$Y$k4X?t(B */
int check_teki_teki(x,y,jibun,sentou)
int x;
int y;
TEKI *jibun;
TEKI *sentou;
{
  TEKI *p;

  p = sentou;

  while( p != NULL ) {

    if ( (jibun != p) &&  check(x,y,p_width,
			       p_height,p->teki_x,p->teki_y,
				    p_width,p_height)
	== 1 )
      return (1);
    p = p->next;
  }
    return (0);
}   

/* $BE($H$Z$s$?$N@\?($rD4$Y$k4X?t(B  */
int check_teki_pen(pen,teki)
PENTA *pen;
TEKI *teki;
{
    if ( check(pen->pen_x,pen->pen_y,p_width,p_height,teki->teki_x,
	       teki->teki_y,p_width,p_height)
	== 1 )
	return (1);
    else
	return (0);
}

/* $B%V%m%C%/$HE($N@\?($rD4$Y$k4X?t(B  */
int check_sp_teki(sp,teki_top)
OBJECT *sp;    /* $B%V%m%C%/$N9=B$BN(B */
TEKI *teki_top; /* $BE($N@~7A%j%9%H$N@hF,(B */
{
    TEKI *t;
    t = teki_top;
    
    if (check(sp->obj_x,sp->obj_y,p_width,p_height,t->teki_x,t->teki_y,
	      p_width,p_height)
	== 1 )
	return (1);
    else
	return (0);
}







