
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <stdio.h>
#include <stdlib.h>
#include "penta.h"


/* $B$Z$s$?$N9=B$BN$N%a%b%j!<$N3NJ](B */
PENTA *get_penta()
{
    PENTA *p;
    /* char *malloc(); */
    
    p = (PENTA *)malloc(sizeof(PENTA));
    if ( p == NULL )
	printf("Not enough memory !! \n");
    return p;
}

/* $B$Z$s$?$N%G!<%?$N%m!<%I(B */
PENTA *load_pen(p,stage)
PENTA *p;
int stage;
{

    static char *num[] = {"0","1","2","3","4","5","6","7","8","9"};
    int x,y,muki;
    char filnam[50];
    FILE *fp;
    char str1[10],str2[10];

    printf("load penta_file name:");
   /* scanf("%s",filnam); */


    strcpy(str1,"./maps/pen");
    strcpy(str2,strcat(str1,num[stage]));
    strcpy(filnam,strcat(str2,".map"));
    printf("%s\n",filnam);

    fp = fopen(filnam,"r");
    if (fp == NULL) {
	printf("Unknow file\n");
	return;
    }
    p = get_penta();
    fscanf(fp,"%d %d %d",&x,&y,&muki);
    
    p->pen_x = x;
    p->pen_y = y;
    p->muki = muki;
    
    fclose(fp);
    return(p);
}

/* $BE($N9=B$BN$N%a%b%j!<$N3NJ](B */
TEKI *get_teki()
{
    TEKI *t;
    /* char *malloc(); */

    t = (TEKI *)malloc(sizeof(TEKI));
    if ( t == NULL )
	printf("Not enough memory !!\n");
    return t;
}

/* $BE($N%G!<%?!<$N%m!<%I!<(B  */
TEKI *load_teki(t,stage)
TEKI *t;
int stage;
{
    static char *num[] = {"0","1","2","3","4","5","6","7","8","9"};
    int point;
    int move;
    int x;
    int y;
    int style;
    char filnam[50],str1[10],str2[10];
    FILE *fp;
    TEKI *tmp;

    printf("load teki_file name:");
/*    scanf("%s",filnam);
*/
   
    strcpy(str1,"./maps/teki");
    strcpy(str2,strcat(str1,num[stage]));
    strcpy(filnam,strcat(str2,".map"));
    printf("%s\n",filnam);

    fp = fopen(filnam,"r");
    if ( fp == NULL ) {
	printf("Unknow file\n");
	return;
    }

    t = get_teki();
    t = NULL;
    while(fscanf(fp,"%d %d %d %d %d",&point,&move,&x,&y,&style) == 5)
	{
	    tmp = t;
	    t = get_teki();
	    t->point = point;
	    t->move = move;
	    t->teki_x = x;
	    t->teki_y = y;
	    t->style = style;
	    t->muki = 3;    /* $BD{@52U=j(B */
	    t->next = tmp;

	}
    fclose(fp);
    return(t);
}


/* $BJ*BN$N9=B$BN$N%a%b%j!<$N3NJ](B */

OBJECT *getobj()
{
    OBJECT *p;
    /* char *malloc(); */

    p = (OBJECT *)malloc(sizeof(OBJECT));
    if ( p == NULL )
	printf("Not enough memory \n");
    return p;
}

/* $BJ*BN$N%G!<%?!<$N%m!<%I(B */
OBJECT *loadfile(p,stage)
OBJECT *p;
int stage;
{

    static char *num[] = {"0","1","2","3","4","5","6","7","8","9"}; 
    int x,y,z;
    char filnam[50],str1[10],str2[10];
    FILE *fp;
    OBJECT *tmp;

    printf("load map file name:");

    /* scanf("%s",filnam); */


    strcpy(str1,"./maps/obj");
    strcpy(str2,strcat(str1,num[stage]));
    strcpy(filnam,strcat(str2,".map"));
    printf("%s\n",filnam);

    fp = fopen(filnam,"r");
    if (fp == NULL) {
	printf("Unknow file\n");
	return;
    }
    p = getobj();
    p = NULL;
    while (fscanf(fp,"%d %d %d",&x,&y,&z) == 3)
{
    tmp = p;
    p = getobj();
    p->obj_x = x;
    p->obj_y = y;
    p->zokusei = z;
    p->next = tmp;
        
}

fclose(fp);
return(p);
}







