
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <stdio.h>
#include <stdlib.h>
#include "penta.h"

PENTA *penta_move(p,keycode)
PENTA *p;
char keycode[10];
{
    int move;
   
    move = 25;    
    /* printf("%s\n",keycode); */ 
    switch(XStringToKeysym(keycode)) {
      case XK_Up :    /* Up */	    
	p->pen_y = p->pen_y - move;
	p->muki =1;
	break;
      case XK_Left :   /* Left */ 
	p->pen_x = p->pen_x - move;
	p->muki =2;
	break;
      case XK_Down :  /* Down */
	p->pen_y = p->pen_y + move;
	p->muki =3;
	break;
      case XK_Right :  /* Right */
	p->pen_x = p->pen_x + move;
	p->muki=4;
	break; 
      case 99: /* stop 99 99 */
	p->pen_x = p->pen_x;
	p->pen_y = p->pen_y;
	p->muki=5;
	break;
      default:
	p->pen_x = p->pen_x;
	p->pen_y = p->pen_y;
	break;
    }
    return(p);
}




PENTA *spring_move(p,keycode)
PENTA *p;
int keycode;
{
    int move;
   
    move = 25;    
   
    switch(keycode) {
      case 1:    /* Up */	    
	p->pen_y = p->pen_y - move;
	p->muki =1;
	break;
      case 2:   /* Left */ 
	p->pen_x = p->pen_x - move;
	p->muki =2;
	break;
      case 3:  /* Down */
	p->pen_y = p->pen_y + move;
	p->muki =3;
	break;
      case 4:  /* Right */
	p->pen_x = p->pen_x + move;
	p->muki=4;
	break; 
      case 99: /* stop 99 99 */
	p->pen_x = p->pen_x;
	p->pen_y = p->pen_y;
	p->muki=5;
	break;
      default:
	p->pen_x = p->pen_x;
	p->pen_y = p->pen_y;
	break;
    }
    return(p);
}








